<template>
    <v-row>
        <v-col>
            <data-table
                v-model="items"
                :title="$t('account')"
                endpoint="api/accounts"
                :filters="filters"
                :headers="headers"
                :search-label="searchLabel"
            >
                <template v-slot:filters="{ filters, confirmed }">
                    <account-filters
                        :roles.sync="filters.roles"
                        @confirmed="confirmed"
                    ></account-filters>
                </template>

                <template v-slot:buttons>
                    <v-btn
                        color="primary"
                        to="/account/create"
                    >
                        <v-icon class="medium" color="white" left>mdi-account-plus</v-icon>
                        {{ $t('account') }}
                    </v-btn>
                </template>

                <template v-slot:item="{ item }">
                    <tr>
                        <td>{{ item.profile.name }}</td>
                        <td>{{ item.email }}</td>
                        <td>{{ item.profile.mobile }}</td>
                        <td>{{ item.created_at | date('Do MMM YYYY') }}</td>
                        <td>
                            <v-menu
                                :close-on-content-click="false"
                                offset-y
                                bottom
                            >
                                <template v-slot:activator="{ on, attrs }">
                                    <v-btn
                                        color="primary"
                                        dark
                                        icon
                                        v-bind="attrs"
                                        v-on="on"
                                    >
                                        <v-icon>mdi-dots-horizontal</v-icon>
                                    </v-btn>
                                </template>
                                <v-list dense>
                                    <v-list-item>
                                        <v-btn
                                            :to="`/user/${item.id}/info`"
                                            class="text-capitalize"
                                            color="primary"
                                            text
                                            block
                                        >
                                            <v-icon left>mdi-eye</v-icon>
                                            {{ $t('view') }}
                                        </v-btn>
                                    </v-list-item>
                                    <v-divider class="my-2"></v-divider>
                                    <v-list-item>
                                        <v-btn
                                            :to="'/account/edit/'+item.id"
                                            class="text-capitalize"
                                            color="primary"
                                            text
                                            block
                                        >
                                            <v-icon left>mdi-pencil</v-icon>
                                            {{ $t('edit') }}
                                        </v-btn>
                                    </v-list-item>
                                </v-list>
                            </v-menu>
                        </td>
                    </tr>
                </template>
            </data-table>
        </v-col>
    </v-row>
</template>

<script>
    import DataTable from "../DataTable";
    import VCountrySelect from "../VCountrySelect";
    import VRoleSelect from "../VRoleSelect";
    import util from "../../../mixins/util";
    import AccountFilters from "../filters/AccountFilters";

    export default {
        name: "Account",
        components: {AccountFilters, VRoleSelect, VCountrySelect, DataTable},
        mixins: [ util ],
        data: () => ({
            filters: {
                roles: []
            },
            items: []
        }),

        computed: {
            headers() {
                return [
                    { text: this.$t('name'), value: 'name' },
                    { text: this.$t('email'), value: 'email' },
                    { text: this.$t('mobile'), value: 'mobile' },
                    { text: this.$t('member_since'), value: 'created_at', sortable: false },
                    { text: this.$t('action'), value: 'actions', sortable: false },
                ]
            },

            searchLabel() {
                return this.$t('search_using', {
                    field: this.$t('name') + ', ' + this.$t('email') + this.$t('or', {
                        field: this.$t('mobile')
                    })
                })
            }
        }
    }
</script>

<style scoped>
</style>
